﻿------------------------------------------------------------------------------------------
--Combo Point-----------------------------------------------------------------------------
------------------------------------------------------------------------------------------
local SN, L, F, T, M, _ = unpack(select(2,...))
local LSM = LibStub("LibSharedMedia-3.0")

local BORDER = 2
local GetShapeshiftFormID = GetShapeshiftFormID
local GetComboPoints = GetComboPoints
local MAX_COMBO_POINTS = MAX_COMBO_POINTS
local CAT_FORM = CAT_FORM
local unpack = unpack
local collectgarbage = collectgarbage

function SN:CPoints(frame)
	local CLASSBAR_WIDTH = SN.data.profile.classResources.width - (BORDER*2)
	local color = M.classResources.ROGUE

	local points = CreateFrame("Frame", nil, frame)
	points:SetSize(CLASSBAR_WIDTH, SN.data.profile.classResources.height)
	points:SetPoint("CENTER", frame, "CENTER", 0, 0)

	if (IsAddOnLoaded("ElvUI")) then
		SN:SNCreateBG(points, "Frame")
	else
		points:SetBackdrop({
			bgFile = M.media.blankTex, 
			edgeFile = M.media.blankTex, 
			tile = false, tileSize = 0, edgeSize = 2, 
			insets = { left = 2, right = 2, top = 2, bottom = 2 }
			})
		points:SetBackdropColor(0.1, 0.1, 0.1, 1)
		points:SetBackdropBorderColor(0.1, 0.1, 0.1, 1)
	end

	for i = 1, MAX_COMBO_POINTS do
		points[i] = CreateFrame("StatusBar", nil, points)
		points[i]:SetSize((SN.data.profile.classResources.width - 22) / MAX_COMBO_POINTS, SN.data.profile.classResources.height - 6)
		if i == 1 then
			points[i]:SetPoint("LEFT", points, 3, 0)
		else
			points[i]:SetPoint("LEFT", points[(i - 1)], "RIGHT", 3, 0)
		end
		
		points[i]:SetStatusBarTexture(LSM:Fetch("statusbar", SN.data.profile.classResources.texture))
		points[i]:GetStatusBarTexture():SetHorizTile(false)
		points[i]:SetMinMaxValues(0, 1)
		points[i]:SetValue(1)
		points[i]:SetStatusBarColor(unpack(color[i]))
	
	end
	
	return points
end

function SN:SetupCombo()
	if (SN.playerClass == "ROGUE" or SN.playerClass == "DRUID") and SN.data.profile.classResources.enable then
		local frame = F.classpower

		frame.points = SN:CPoints(frame)
		F.classpower.frame[#frame.frame + 1] = frame.points
		frame.points:RegisterEvent("UNIT_COMBO_POINTS")
		frame.points:RegisterEvent("PLAYER_TARGET_CHANGED")
		frame.points:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
		frame.points:RegisterEvent("PLAYER_ENTERING_WORLD")

		frame.points:SetScript("OnEvent", function(self, event, ...)
			if event == "UNIT_COMBO_POINTS" then
				local cpoints = GetComboPoints("player", "target")
				if cpoints > 0 then
					for i = 1, cpoints do
						self[i]:SetAlpha(1)
					end
				else
					for i = 1, MAX_COMBO_POINTS do
						self[i]:SetAlpha(0.2)
					end
				end
			elseif event == "PLAYER_TARGET_CHANGED" then
				local cpoints = GetComboPoints("player", "target")
				if cpoints > 0 then
					for i = 1, cpoints do
						self[i]:SetAlpha(1)
					end
				else
					for i = 1, MAX_COMBO_POINTS do
						self[i]:SetAlpha(0.2)
					end
				end
			end

			if event == "UPDATE_SHAPESHIFT_FORM" then
				local form = GetShapeshiftFormID()
				if SN.playerClass == "DRUID" then
					if form == CAT_FORM then
						SN:ComboEnable()
					else
						SN:ComboDisable()
					end
				end
			end
		
			if event == "PLAYER_ENTERING_WORLD" then
				local form = GetShapeshiftFormID()
				if SN.playerClass == "DRUID" then
					if form == CAT_FORM then
						SN:ComboEnable()
					else
						SN:ComboDisable()
					end
				end
			end
		end)
		local cpoints = GetComboPoints("player", "target")

		if cpoints > 0 then
			for i = 1, cpoints do
				frame.points[i]:SetAlpha(1)
			end
		else
			for i = 1, MAX_COMBO_POINTS do
				frame.points[i]:SetAlpha(0.2)
			end
		end
		local form = GetShapeshiftFormID()
		if SN.playerClass == "DRUID" then
			if form == CAT_FORM then
				SN:ComboEnable()
			else
				SN:ComboDisable()
			end
		end
	end
end

function SN:ComboEnable()
	local frame = F.classpower
	frame.points:Show()
	frame.points:RegisterEvent("UNIT_COMBO_POINTS")
	frame.points:RegisterEvent("PLAYER_TARGET_CHANGED")
end

function SN:ComboDisable()
	
	local frame = F.classpower
	frame.points:UnregisterEvent("UNIT_COMBO_POINTS")
	frame.points:UnregisterEvent("PLAYER_TARGET_CHANGED")
	frame.points:Hide()
	collectgarbage("collect")
end